<%inherit file="base.html"/>
<%!
    import lazylibrarian
%>
<%def name="headerIncludes()">
    <div id="subhead_container">
        <div id="subhead_menu">
          %if perm&lazylibrarian.perm_status:
            <a href="clearhistory?status=all" class="button btn btn-sm btn-primary"><i class="far fa-square"></i> Clear All History</a>
            <a href="clearhistory?status=Processed" class="button btn btn-sm btn-primary"><i class="fa fa-check-square"></i> Clear Processed</a>
            <a href="clearhistory?status=Snatched" class="button btn btn-sm btn-primary"><i class="fa fa-plus-square"></i> Clear Snatched</a>
            <a href="clearhistory?status=Failed" class="button btn btn-sm btn-primary"><i class="fa fa-minus-square"></i> Clear Failed</a>
          %endif
            <button class="button btn btn-sm btn-primary" type="button" value="showdownloads" id="showdownloads"><i class="fa fa-list-ol"></i> Download Count</button>
        </div>
    </div>
</%def>

<%def name="body()">
    <h1>${title}</h1>
    <div class="table-responsive">
        %if lazylibrarian.CONFIG['TOGGLES'] == True:
        Toggle: <a class="toggle-vis" data-column="0"> Title</a>
        <a class="toggle-vis" data-column="1"> Type</a>
        <a class="toggle-vis" data-column="2"> ID</a>
        <a class="toggle-vis" data-column="3"> Provider</a>
        <a class="toggle-vis" data-column="4"> Date</a>
        <a class="toggle-vis" data-column="5"> Size</a>
        <a class="toggle-vis" data-column="6"> Status</a>
        <p>&nbsp;</p>
        %endif
        <table class="display table table-striped table-hover table-bordered" id="book_table">
            <thead>
                <tr>
                    <th class="filename">Title</th>
                    <th class="type">Type</th>
                    <th class="bookid">ID</th>
                    <th class="provider">Provider</th>
                    <th class="dateadded">Date</th>
                    <th class="size text-right">Size</th>
                    <th class="status text-center">Status</th>
                    <th class="hidden">percent</th>
                </tr>
            </thead>
</table>
</div>

</%def>
<%def name="headIncludes()">
</%def>
<%def name="javascriptIncludes()">
  <script type="text/javascript">

    function dlinfo(target) {
        var res = target.split('^');
        var status = res[0]
        var rowid = res[1]
        $.get('dlinfo', {'target': target},
        function(data) {
            bootbox.dialog({
                title: 'Download '+ status,
                message: '<pre>'+data+'</pre>',
                buttons: {
                    bt1: {
                        label: "Mark Failed",
                        className: 'btn-warning',
                        callback: function(){ $.get("markhistory", { 'rowid': rowid }, function (data) {});
                                                    location.reload(true); }
                    },
                    bt2: {
                        label: "Delete",
                        className: 'btn-danger',
                        callback: function(){ $.get("deletehistory", { 'rowid': rowid }, function (data) {});
                                                    location.reload(true); }
                    },
                    primary: {
                        label: "Close",
                        className: 'btn-primary'
                    }
                }
            });
        });
    };

    $(document).ready(function()
    {
       var timer;

       $('#showdownloads').on('click', function(e) {
            $.get('showdownloads', function(data) {
                bootbox.dialog({
                    title: 'Successful Downloads',
                    message: '<pre>'+data+'</pre>',
                    buttons: {
                        %if perm&lazylibrarian.perm_status:
                        prompt: {
                            label: "Clear Counters",
                            className: 'btn-danger',
                            callback: function(){ $.get("cleardownloads", function(e) {}); }
                        },
                        %endif
                        primary: {
                            label: "Close",
                            className: 'btn-primary'
                        },
                    }
                });
            });
        });

        var table = $('#book_table').DataTable(
            {
                "responsive": true,
                "bAutoWidth": false,
                "stateSave": true,
                "order": [[ 4, 'desc' ]],
                "columnDefs":[
                    { targets: [1], 'render': function(data, type, row) {
                        var ftype = row[1]
                        if ( ftype == 'None' ) {ftype = 'eBook'}
                        if ( ftype.match(/^[0-9.-]+$/) != null ) {ftype = 'Magazine'}
                        return ftype;} },
                    { targets: [4],
                        'class': 'text-center',
                        'render': function(data, type, row) {
                            return '<a data-toggle="tooltip" title="' + row[11] + '">' + row[4] + '</a>';} },
                    { targets: [5], 'render': function(data, type, row) {
                        return '<div class="text-right">' + data + '</div>';} },
                    { targets: [6],
                        'class': 'text-center',
                        'render': function(data, type, row) {
                        if ( row[9] <= 0 ) {
                          %if perm&lazylibrarian.perm_status:
                            bar = '<button onclick="dlinfo(\'' + data + '^' + row[10] +
                            '\')" class="button btn btn-xs btn-primary" type="button">' + data + 
                            '</button>';
                          %else:
                            bar = data;
                          %endif
                        }
                        else {
                            if ( row[9] <= 25 ) { css = 'danger' }
                            else if ( row[9] <= 50 ) { css = 'warning' }
                            else if ( row[9] <= 75 ) { css = 'info' }
                            else { css = 'success' };
                            %if perm&lazylibrarian.perm_status:
                            bar = '<button onclick="dlinfo(\'' + data + '^' + row[10] +
                            '\')" class="button btn btn-xs btn-link" type="button">' 
                            %else:
                            bar = ''
                            %endif
                            bar += '<div class="progress center-block" style="width: 120px;"><div class="progress-bar-' +
                            css + ' progress-bar progress-bar-striped" role="progressbar aria-valuenow="' + row[9] +
                            '" aria-valuemin="0" aria-valuemax="100" style="width: ' + row[9] +
                            '%;"><span class="sr-only">' + row[9] +
                            '% Complete</span><span class="progressbar-front-text">' + row[9] + 
                            '%</span></div></div>'
                            %if perm&lazylibrarian.perm_status:
                            bar += '</button>'
                            %endif
                            };
                        return bar;} },
                ],
                "oLanguage": {
                    "sSearch": "Filter: ",
                    "sLengthMenu":"_MENU_ rows per page",
                    "sEmptyTable": "No history found",
                    "sInfo":"Showing _START_ to _END_ of _TOTAL_ rows",
                    "sInfoEmpty":"Showing 0 to 0 of 0 rows",
                    "sInfoFiltered":"(filtered from _MAX_ total rows)"},
                "bServerSide": true,
                "sAjaxSource": 'getHistory',
                "bFilter": true,
                "sPaginationType": "full_numbers",
                "aLengthMenu": [[5, 10, 15, 25, 50, 100, -1], [5, 10, 15, 25, 50, 100, "All"]],
                "iDisplayLength": ${lazylibrarian.CONFIG['DISPLAYLENGTH']},
                "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {
                    $('td', nRow).eq(7).addClass('hidden');
                    return nRow;
                },
                "aaSorting": [[4, 'desc']],
            });
            $('.dataTables_filter input').attr("placeholder", "Results filter");
            $('a.toggle-vis').click(function (e) {
                e.preventDefault();
                var column = table.column( $(this).attr('data-column') );
                column.visible( ! column.visible() );
            } );

        if(timer)
        {
            clearInterval(timer);
        }
        if ( ${lazylibrarian.HIST_REFRESH} > 0 ) {
            timer = setInterval( function () { table.ajax.reload( null, false ); }, ${lazylibrarian.HIST_REFRESH} );
        };

        //enable datatables console logging
        //table.on(function ( e ) {
        //   console.log( e ); } );
    });
  </script>

</%def>
